import * as React from 'react';
import { equals, getDisplayName } from '../utils';
/**
 * @deprecated Use `createConnectedStore` instead.
 */
export function connect(store) {
    return function (Component) {
        var _a;
        return _a = class extends React.Component {
                constructor() {
                    super(...arguments);
                    this.state = {
                        store: store.getCurrentSnapshot(),
                        subscription: store.onAll().subscribe(({ previousValue, value }) => {
                            if (equals(previousValue, value)) {
                                return false;
                            }
                            this.setState({ store: store.getCurrentSnapshot() });
                        })
                    };
                }
                componentWillUnmount() {
                    this.state.subscription.unsubscribe();
                }
                shouldComponentUpdate(props, state) {
                    return state.store !== this.state.store
                        || Object.keys(props).some(_ => props[_] !== this.props[_]);
                }
                render() {
                    return React.createElement(Component, Object.assign({}, this.props, { store: this.state.store }));
                }
            },
            _a.displayName = `withStore(${getDisplayName(Component)})`,
            _a;
    };
}
//# sourceMappingURL=connect.js.map